#This is where most calls and the 5-room system for the 3 minigames are set for The Nettestadt Troll.
#The code is open-sourced for personal use only.
#Do not redistribute the game with modified code unless you have permission from the author.

label setday:
# Set location and Day mode for the loop
# Set dynamic displayables to correct day mode
    $ cottageinsider = cottageinsideday
    $ cottagefronter = cottagefrontday
    $ meadowser = meadowsday
    $ nettestadter = nettestadtday
    $ milltaverner = milltavernday
# Set composited images to correct day for image maps
    $ cottagefrontbase = cottagefrontbaseday
    $ cottagefronthover = cottagefronthoverday
    $ cottagefronterscaler = cottagefronterscalerday
    
    $ cottageinsidebase = cottageinsidebaseday
    $ cottageinsidehover = cottageinsidehoverday
    $ cottageinsiderscaler = cottageinsiderscalerday

    $ meadowsbase = meadowsbaseday
    $ meadowshover = meadowshoverday
    $ meadowserscaler = meadowserscalerday
    
    $ milltavernbase = milltavernbaseday
    $ milltavernhover = milltavernhoverday
    $ milltavernerscaler = milltavernerscalerday
    
    $ nettestadtbase = nettestadtbaseday
    $ nettestadthover = nettestadthoverday
    $ nettestadterscaler = nettestadterscalerday
    return

label setnight:
# Set location and Night mode for the loop
# Set dynamic displayables to correct night
    $ cottageinsider = cottageinsidenight
    $ cottagefronter = cottagefrontnight
    $ meadowser = meadowsnight
    $ nettestadter = nettestadtnight
    $ milltaverner = milltavernnight
# Set composited images to correct night for image maps
    $ cottagefrontbase = cottagefrontbasenight
    $ cottagefronthover = cottagefronthovernight
    $ cottagefronterscaler = cottagefronterscalernight
    
    $ cottageinsidebase = cottageinsidebasenight
    $ cottageinsidehover = cottageinsidehovernight
    $ cottageinsiderscaler = cottageinsiderscalernight

    $ meadowsbase = meadowsbasenight
    $ meadowshover = meadowshovernight
    $ meadowserscaler = meadowserscalernight
    
    $ milltavernbase = milltavernbasenight
    $ milltavernhover = milltavernhovernight
    $ milltavernerscaler = milltavernerscalernight
    
    $ nettestadtbase = nettestadtbasenight
    $ nettestadthover = nettestadthovernight
    $ nettestadterscaler = nettestadterscalernight
    return

label setpast:
# Set main locations to sepia or grayscale
    $ cottageinsider = im.Grayscale(cottageinsidenight)
    $ cottagefronter = im.Sepia(cottagefrontday)
    $ meadowser = im.Sepia(meadowsday)
    $ nettestadter = im.Sepia(nettestadtday)
    $ milltaverner = im.Grayscale(milltavernday)

    $ cottageinsiderscaler = im.Grayscale(cottageinsiderscalernight)
    $ cottagefronterscaler = im.Sepia(cottagefronterscalerday)
    $ meadowserscaler = im.Sepia(meadowserscalerday)
    $ nettestadterscaler = im.Sepia(nettestadterscalerday)
    $ milltavernerscaler = im.Grayscale(milltavernerscalerday)
    return
    
label preparelocation:
    $ ts_visits = 0
    $ well_visit = False
    $ first_meal = 0
    $ typemeal = "defaultmeal"
    $ treasureone_location = 0
    $ treasurefound = False
    $ guard1_hungry = True
    $ guard2_hungry = True
    $ statutes_stage = 0
    $ registrar_stage = 0
    $ pocketed_meal = False
    $ gold = 0
    $ notauntreunion = True
    $ notmillerpre = True
    $ oldwomannotencounteredyet = True
    $ haveflowers = False
    $ writtennote = False
    call zeroyield from _call_zeroyield_1
    call zeromeat from _call_zeromeat_1
    return
    
label discovery1:
    $ treasurefound = True
    kneutral "What is this?"
    kthink "I pick something up... it seems to be a golden flower.  After inspecting it, I pocket the object."
    kneutral "Back to the original search."
    return

label notime:
    $ renpy.music.play("trollthemeshort.ogg", fadein=1.0)
    kthink "I have no time to think."
    kthink "As if driven by pure instinct, I dart out of the library, then through corridors, dodging servants and court staff I encounter along the way."
    kthink "I hear shouts behind me, but it does not matter.  Let them think what they want, as long as they do not think too much."
    kthink "Like Cinderella who had lost her slipper, or, more like a cat who had already gotten its prey, I use light footsteps to dart across grand ballrooms and down central staircases."
    kthink "At last I reach the gates, and having no time to think, I go straight ahead."
    kthink "The last stretch seems like an eternity, but finally I pass through the archway and continue without stopping."
    guard "Stupid nobles and their stupid games."
    kthink "The other guard mumbles incoherently."
    kthink "I can barely think, all I know is to just run away.  Thankfully, I encounter no one else along the way that seems to care."
    $ renpy.music.stop(fadeout=2.0)
    scene meadowsS with fade
    kthink "When I reach a safe distance, I slow down to rest.  What will happen now?"
    kthink "I try to rationalize to myself that everything will be alright."
    play music("njoy.ogg", "njoy.ogg", "njoy2.ogg", "njoy2.ogg")
    if (runbook):
        kthink "First, I did not answer the baroness.  Which means, she does not know me and does not know my purpose."
        kthink "Will that guarantee my safety?  Can I just think that she assumes I am one of the villager girls sponsored by some noble?"
        kthink "Will she care enough to investigate about me, send for me, then punish me?  I did steal a book from the castle library, after all."
        kneutral "At least she does not know exactly where I live, so as long as I avoid the downtown streets, I should be alright."
        scene cottageinsideS at LL with fade
        kthink "At length I rest enough and open the book I stole from the library.  Its words, as expected, will never hold meaning for me."
        kthink "It is too late to go back now.  This will have to suffice for the troll."
    else:
        kthink "No one really saw me and took a good look at me.  So it is just like before."
        kneutral "I should avoid Nettestadt Castle now, but should be able to continue on with my daily living."
        kneutral "I just have to tell the troll the truth that I simply could not find the book with the exact title."
        kthink "That was my conclusion."
    $ renpy.music.stop(fadeout=1.0)
    scene black with Dissolve(2.0)
    return

label purchasemiller:
    menu:
        "Buy Pork (50 Gold)":
            if (gold >= 50):
                play sound("change.ogg")
                kneutral "Some ham and sausages please."
                miller "Here you go."
                $ yieldpork += 1
                $ gold -= 50
            else:
                kneutral "Oh, I do not have enough money anymore for this item."
            jump purchasemiller
        "Buy Bread (20 Gold)":
            if (gold >=20):
                play sound("change.ogg")
                kneutral "Some bread please."
                miller "Right away, madam."
                $ yieldbread += 1
                $ gold -= 20
            else:
                kneutral "Oh, I do not have enough money anymore for this item."
            jump purchasemiller
        "Buy Cheese (35 Gold)":
            if (gold >= 35):
                play sound("change.ogg")
                kneutral "I would like some cheese."
                miller "Very well."
                $ yieldcheese += 1
                $ gold -=35
            else:
                kneutral "Oh, I do not have enough money anymore for this item."
            jump purchasemiller
        "Check Wallet.":
            kneutral "It looks like I have %(gold)d Gold."
            jump purchasemiller
        "Stop Purchasing.":
            ksmile "I better leave now before I run out of money."
    return
    
label selltoaunt:
    menu:
        "Sell Cabbage (10 Gold)":
            if (yieldcabbage > 0):
                kneutral "Can you buy some cabbage from me?"
                play sound("change.ogg")
                aunt "Gladly."
                $ yieldcabbage -= 1
                $ gold += 10
            else:
                kneutral "Oh, I do not have enough of this item to sell."
            jump selltoaunt
        "Sell Parsley (15 Gold)":
            if (yieldparsley > 0):
                kneutral "Have some parsley, if you wish."
                play sound("change.ogg")
                aunt "Looks fresh."
                $ yieldparsley -= 1
                $ gold += 15
            else:
                kneutral "Oh, I do not have enough of this item to sell."
            jump selltoaunt
        "Sell Potato (25 Gold)":
            if (yieldpotato > 0):
                kneutral "Potatoes for your vegetable grinder."
                play sound("change.ogg")
                aunt "I think you have the wrong idea, but still..."
                $ yieldpotato -= 1
                $ gold +=25
            else:
                kneutral "Oh, I do not have enough of this item to sell."
            jump selltoaunt
        "Sell Onion (20 Gold)":
            if (yieldonion > 0):
                kneutral "Some fresh onions for sale."
                play sound("change.ogg")
                aunt "Gladly, my dear."
                $ yieldonion -= 1
                $ gold += 20
            else:
                kneutral "Oh, I do not have enough of this item to sell."
            jump selltoaunt
        "Sell Asparagus (10 Gold)":
            if (yieldasparagus > 0):
                kneutral "Would you like some asparagus?"
                play sound("change.ogg")
                aunt "Sure."
                $ yieldasparagus -= 1
                $ gold +=10
            else:
                kneutral "Oh, I do not have enough of this item to sell."
            jump selltoaunt
        "Check Wallet.":
            kneutral "It looks like I have %(gold)d Gold."
            jump selltoaunt
        "Stop Purchasing.":
            ksmile "I better leave now before I run out of stock."
    $ first_meal = 0 #This enables you to totally empty your stock for gold, and harvest a fresh batch
    return

label alchemistsequence:
    if (registrar_stage == 0):
        kthink "An Alchemist is sweeping the entrance to the Hall.  She notices me and looks up."
        alchemist "You have to move along, Fraulein."
        alchemist "We are conducting many sensitive experiments and do not want them to be disturbed by the noise of passers-by."
        kneutral "But I have a question..."
        kthink "I remember the advice the troll told me."
        kneutral "...the Troll sent me."
        kthink "The Alchemist stops her sweeping, and looks up immediately."
        alchemist "Alright.  Just wait here a second."
        kthink "The Alchemist disappears inside the building, then reemerges."
        alchemist "We will need you to fetch some yellow flowers from Blumenwald, then bring them back here."
        if (haveflowers):
            kneutral "Oh, but I happen to have some in my basket..."
            kthink "The Alchemist inspects the ones I picked earlier, but shakes her head."
            alchemist "I am afraid those will not do.  You will have to pick better ones."
        kneutral "Alright.  But before I leave, can I ask you a question?"
        alchemist "Sure."
        kneutral "Who do you think the troll is?"
        alchemist "You do not know by now?  And I thought you were living with him!"
        kneutral "Well he visits... to, um... but he is always under the cover of night."
        alchemist "It is Uwe, most definitely!"
        alchemist "Only a lad born into such wealth and privilege has the connections and power to execute such an elaborate scenario."
        kneutral "You really think so?"
        alchemist "You may choose to believe me or not, but I am definitely convinced."
        alchemist "This is just yet another one of the games of the elite."
        kthink "I take my leave with new things to think about."
        $ registrar_stage = 1
    elif (registrar_stage == 1):
        alchemist "Oh Katja, you are back."
        if (haveflowers):
            kthink "I hand the flowers to the alchemist."
            alchemist "They look nice.  Hold on for a minute."
            kthink "The Alchemist goes inside the building with the flowers, then comes back out with the flowers all packaged."
            kthink "There is even a little tag on the bouquet."
            alchemist "Sorry to be such a burden to you, but could you deliver this to the bartender at the tavern?"
            kthink "Now I am getting curious."
            kneutral "Sure."
            kthink "As I walk away, I start to wonder whether to deliver the bouquet directly to the bartender, or if I should go home first.  After all, I still have time."
            $ haveflowers = False
            $ registrar_stage = 2
        else:
            alchemist "Oh, you do not have the flowers yet?  Come back when you have them."
    elif (registrar_stage == 2):
        if (writtennote):
            kthink "I hand the bartender's note to the Alchemist."
            if (nettestadter == nettestadtnight):
                kthink "She inspects it then replies."
                alchemist "Good work, Katja.  You may enter."
                jump library_sequence
            else:
                alchemist "I am afraid we cannot let you in yet, it will arouse too much suspicion."
                alchemist "There are too many other Alchemists and not all of them share the same goals."
                alchemist "Get some rest, then come back in the evening."
                alchemist "Keep the note for now, it will be your pass."
        else:
            alchemist "Katja, deliver the bouquet to the bartender.  Do not worry, he will not misinterpret it as coming from you."
    return

label guardsequence:
    if (statutes_stage == 0):
        kthink "Two guards are in front of the castle gates.  I approach them timidly, and having had no real time to make an alibi..."
        kthink "...go directly to the point."
        kneutral "How can a young woman be able to freely enter this Castle?"
        kthink "The guards look at each other briefly, and one mutters..."
        guard "Another one of them for these damn nobles."
        kthink "The other guard, with no hint of amusement, responds directly to me."
        guard "Fraulein, our requirements are simple.  A ham sandwich for me, and a bratwurst for him."
        kneutral "Food?"
        if (pocketed_meal):
            kneutral "Oh, I have food with me in my basket right now..."
            kthink "The guards both look inside then shake their heads."
            guard "That may be good for you, but for us, you will have to try again."
        guard "Yes, make us those meals, and in the evening, we will let you in."
        kneutral "I see. But why evening?"
        guard "Have you ever heard of the word, 'discretion'?"
        kneutral "I take it you do not recognize me."
        guard "You?  You are just a fine young lass like any fine young lass.  Why do you ask?"
        kneutral "...nothing."
        kthink "They do not recognize me as the troll's concubine at least."
        kthink "I suppose royal guards are too busy doing their duties to be partaking of rumors."
        kneutral "Alright.  I will be back."
        kthink "I turn around and walk off, but I overhear the conversation they mutter among themselves."
        guard "Young women these days... I wish the troll gets them."
        guard "I remember when the troll kept the peace the nightwatchmen could never hope to achieve."
        guard "Perhaps the troll was Jakob the nightwatchman after all... may his soul rest in peace."
        $ statutes_stage = 1
    elif (statutes_stage == 1):
        if (guard1_hungry == False) and (guard2_hungry == False):
            if (nettestadter == nettestadtnight):
                guard "You may enter."
                jump library_sequence
            else:
                guard "Get some rest, then come back in the evening."
        elif (guard1_hungry) and (pocketed_meal) and (typemeal == "ham and cheese sandwich"):
            kthink "I hand the ham sandwich to the first guard."
            $ first_meal = 0 #This enables you to harvest and cook again.
            $ pocketed_meal = False
            guard "Thank you, this looks delicious."
            $ guard1_hungry = False
            if (guard2_hungry):
                kthink "The other guard speaks up."
                guard "What about my bratwurst?"
                kneutral "I will be back, I can only carry so much in my basket."
            else:
                guard "Now we are both full."
                if (nettestadter == nettestadtnight):
                    guard "You may enter."
                    jump library_sequence
                else:
                    guard "Get some rest, then come back in the evening."
        elif (guard2_hungry) and (pocketed_meal) and (typemeal == "bratwurst"):           
            kthink "I hand the bratwurst to the second guard."
            $ first_meal = 0 #This enables you to harvest and cook again.
            $ pocketed_meal = False
            guard "Thank you, this looks delicious.  And you did not forget the sauerkraut!"
            $ guard2_hungry = False
            if (guard1_hungry):
                kthink "The other guard speaks up."
                guard "What about my ham sandwich?"
                kneutral "I will be back, I can only carry so much in my basket."
            else:
                guard "Now we are both full."
                if (nettestadter == nettestadtnight):
                    guard "You may enter."
                    jump library_sequence
                else:
                    guard "Get some rest, then come back in the evening."
        elif (guard1_hungry == False) or (guard2_hungry == False):
            guard "Do you have the rest of our food?"
            kneutral "I am working on it."
        else:
            guard "Do you have our food?"
            if (not pocketed_meal):
                kneutral "No, not yet."
                guard "Then get to work, woman!"
            else:
                kthink "The guard grabs what is in my basket."
                guard "What the... %(typemeal)s!  That is not what we requested!"
            kthink "I think those guards are bastards."
    return

label zeroyield:
    $ yieldcabbage = 0
    $ yieldparsley = 0
    $ yieldpotato = 0
    $ yieldonion = 0
    $ yieldasparagus = 0
    $ mealcomplete = False
    return
    
label zeromeat:
    $ yieldpork = 0
    $ yieldbread = 0
    $ yieldcheese = 0
    return
    
label eatorpackit:
    menu:
        "Eat the meal.":
            $ pocketed_meal = False
            kthink "I consume the meal, at least I am not hungry myself."
            $ first_meal = 0 #enables you to harvest and cook again.
        "Keep it in the basket.":
            $ pocketed_meal = True
            kneutral "Let us hope is is not cold by the time I deliver it."
    return

label declarelacking:
    kneutral "Some ingredients are lacking, so I cannot make this meal."
    $ mealcomplete = False
    jump retrycooking
    
label cookingprocess:
    kneutral "Alfrieda left me a recipe book.  I may not be able to make everything due to lack of ingredients, but let us see..."
    kneutral "I wonder what type of meal I shall make now?"
label retrycooking:
    menu:
        "Kartoffelsalat":
            kneutral "I will need parsley, potato, and onion."
            if (yieldparsley > 0) and (yieldpotato > 0) and (yieldonion > 0):
                $ yieldparsley -= 1
                $ yieldpotato -= 1
                $ yieldonion -= 1
                $ typemeal = "kartoffelsalat"
                $ mealcomplete = True
            else:
                jump declarelacking
        "Bratwurst":
            kneutral "I will need cabbage, onion, pork, and bread."
            if (yieldcabbage > 0) and (yieldonion > 0) and (yieldpork > 0) and (yieldbread > 0):
                $ yieldcabbage -= 1
                $ yieldonion -= 1
                $ yieldpork -= 1
                $ yieldbread -= 1
                $ typemeal = "bratwurst"
                $ mealcomplete = True
            else:
                jump declarelacking
        "Cabbage Salad":
            kneutral "I will need cabbage."
            if (yieldcabbage > 0):
                $ yieldcabbage -= 1
                $ typemeal = "cabbage salad"
                $ mealcomplete = True
            else:
                jump declarelacking
        "Baked Asparagus":
            kneutral "I will need parsley, potato, asparagus, and cheese."
            if (yieldparsley > 0) and (yieldpotato > 0) and (yieldasparagus > 0) and (yieldcheese > 0):
                $ yieldparsley -= 1
                $ yieldpotato -= 1
                $ yieldasparagus -= 1
                $ yieldcheese -= 1
                $ typemeal = "baked asparagus"
                $ mealcomplete = True
            else:
                jump declarelacking            
        "Ham and Cheese Sandwich":
            kneutral "I will need pork, bread, and cheese."
            if (yieldpork > 0) and (yieldbread > 0) and (yieldcheese > 0):
                $ yieldpork -= 1
                $ yieldbread -= 1
                $ yieldcheese -= 1
                $ typemeal = "ham and cheese sandwich"
                $ mealcomplete = True
            else:
                jump declarelacking  
        "Asparagus Soup":
            kneutral "I will need asparagus."
            if (yieldcabbage > 0):
                $ yieldasparagus -= 1
                $ typemeal = "asparagus soup"
                $ mealcomplete = True
            else:
                jump declarelacking   
        "Cancel":         
                $ typemeal = "defaultmeal"
                $ mealcomplete = False
    return

#This is the basic 5-location engine for the 3 minigames.  The full minigame comes with two flavors, depending on the troll.
label locationcycler:
    if (location == 'cottageinside'):
        scene cottageinside with fade
        kneutral "I welcome myself to my humble abode."
        $ cottageresult = renpy.imagemap(cottageinsidebase, cottageinsidehover, [
            (0, 380, 400, 600, "table"),
            (0, 0, 400, 340, "kitchen"), 
            (440, 0, 800, 350, "bed"),
            (460, 400, 800, 600, "doorout"),
            ], focus="imagemap")   
        play sound("click.ogg")
        if cottageresult == "table":
            kneutral "What tasks do I have to do?"
            scene cottageinsideS at LL with fade
            if (locationscenario == 'orientation'):
                kneutral "I have to bathe and eat a meal."
            elif (locationscenario == 'errands'):
                if (quest == "statutes book"):
                    kneutral "I must get the book called ''Statutes of Common Law'' from the Nettestadt Castle library."
                    if (statutes_stage == 1):
                        kneutral "To do this, I must first bribe the guards with bratwurst and a ham sandwich."
                        kneutral "I may need to go to the miller to get my meat and dairy products."
                        kneutral "But since I have no money, I may first need to trade some vegetables at the market."
                        kneutral "Then after cooking, I can only carry one meal in my basket and deliver it one at a time."
                elif (quest == "registrar book"):
                    kneutral "I must get the ''Registrar of Alchemists'' from the Hall of Alchemy."
                    if (registrar_stage == 1):
                        kneutral "To do this, I must first deliver some flowers to the Hall of Alchemy."
                    elif (registrar_stage == 2):
                        kthink "I have some items to be delivered, but my curiousity is getting to me."
                        menu:
                            "Read what is written inside.":
                                if(writtennote):
                                    kthink "I open the note the bartender gave me to be used as a pass for the Hall of Alchemy."
                                    kthink "It read, ''Please let this woman in to do her tasks as the troll instructed.''"
                                    kthink "It was signed by the bartender himself."
                                    kneutral "Well, what else could I expect?"
                                else:
                                    kthink "I read the tag on the bouquet of flowers I am supposed to give to the bartender."
                                    kthink "''Dear Alfrieda, please do not be sad, since everything will get better in time.''"
                                    kthink "''This bouquet would have been delivered to you by the bartender...''"
                                    kthink "''Since I am too ashamed to bring this personally to you.''"
                                    kthink "''I dare not also request someone in close contact with you to do this, hence the third party.''"
                                    kthink "''But you see, Katja picked these flowers for you, although she does not know it.''"
                                    kthink "''I had Katja hand-pick the flowers for you, to show you that she cares.''"
                                    kthink "''I love Katja, but as your brother, I am concerned also for your happiness.''"
                                    kthink "''Rest assured, I am well.  Signed, the troll.''"
                                    kscared "Alfrieda's brother..."
                                    ksmile "I know now who the troll is." #Haha if the player manages to get to this, I already gave a clue.
                                    $ evidence = "Jakob"
                            "Do not read what is supposed to be confidential.":
                                kneutral "Yes, I must be trustworthy, even for covert matters."
            else:
                kneutral "Nothing to do yet."
        if cottageresult == "kitchen":
            kneutral "I am off to my cauldron."
            scene cottageinsideS at UL with fade
            if (locationscenario == 'orientation'):
                if (first_meal == 1):
                    kneutral "I am so hungry."
                    call cookingprocess from _call_cookingprocess_1
                    if (typemeal == "defaultmeal"):
                        kneutral "I cannot really cook anything at this time.  I will try again later."
                    else:
                        ksmile "That was a delicious %(typemeal)s!"
                        $ first_meal = 2
                        if (well_visit == True):
                            jump afterorientation
                elif (first_meal == 2):
                    kneutral "I have already eaten, I must find something else to do."
                elif (first_meal == 0):
                    kneutral "There is nothing to cook.  I must harvest some vegetables first."
            elif (locationscenario == 'errands'):
                if (pocketed_meal):
                    kneutral "I still have a meal I have to dispose of, so I cannot cook yet."
                    call eatorpackit from _call_eatorpackit_1
                else:
                    call cookingprocess from _call_cookingprocess_2
                    if (mealcomplete):
                        ksmile "I made %(typemeal)s!"
                        call eatorpackit from _call_eatorpackit_2
                    else:
                        kneutral "I cannot proceed unless I cook something, but oh well."
            else:
                ksmile "Cooking, cooking..."
        if cottageresult == "bed":
            kneutral "I need to rest a bit."
            scene cottageinsideS at UR with fade
            kthink "I lie down on my bed."
            menu:
                "Rest for a short time.":
                    kthink "So I spend some time laying in bed."
                "Rest for many hours.":
                    kthink "I rest until the moon and the sun exchange places."
                    scene black with Dissolve(0.5)
                    if (cottageinsider == cottageinsideday):
                        call setnight from _call_setnight_1
                    else:
                        call setday from _call_setday_1
                    scene cottageinsideS at UR with fade
                    kneutral "I think I may have overslept."
                    if (cottageinsider == cottageinsidenight) and (locationscenario == 'errands'):
                        kthink "I notice that the troll is in the cottage."
                        t "Katja."
                        kneutral "Mr. Troll... not tonight, I am tired."
                        t "Alright..."
                        t "How are you doing?"
                        kneutral "I am working hard, but I will get it done."
                        t "Good.  Well, see you next time.  Good evening, Milady."
                        kthink "I wish he would stay for longer, even if we do nothing."
        elif cottageresult == "doorout":
            kneutral "I will step outside."
            $ location = 'cottagefront'
    elif (location == 'cottagefront'):
        scene cottagefront with fade
        kneutral "I can never get used to this architecture."
        $ cottageresult = renpy.imagemap(cottagefrontbase, cottagefronthover, [
            (50, 310, 400, 600, "garden"),
            (0, 0, 200, 280, "pathout"), 
            (420, 150, 740, 360, "doorin"),
            (420, 380, 800, 600, "well"),
            ], focus="imagemap")  
        play sound("click.ogg")            
        if cottageresult == "garden":
            kneutral "I will try to grow some vegetables in my garden."
            scene cottagefrontS at LL with fade
            if (locationscenario == 'orientation'):
                if (first_meal == 0):
                    kneutral "I will need my packs of seeds and a trowel."
                    $ yieldcabbage += renpy.random.randint(1, 5)
                    $ yieldparsley += renpy.random.randint(1, 5)
                    $ yieldpotato += renpy.random.randint(1, 5)
                    $ yieldonion += renpy.random.randint(1, 5)
                    $ yieldasparagus += renpy.random.randint(1, 5)
                    kthink "I identify empty spots in the vegetable garden."
                    kthink "I remove some weeds, then break apart the soil."
                    kneutral "I am not really meant to be a gardener, but I will try my best."
                    kthink "I grab some seeds and scatter them, then place some soil back on top."
                    kneutral "Ewww, earthworms!"
                    scene cottagefrontS at LL with vpunch
                    kthink "A sudden jolt, and I am taken aback."
                    kscared "What... in the world... is this?"
                    kthink "In a matter of seconds, the seeds I have planted sprout and grow and ripen."
                    kneutral "I know alchemy can do a lot of things that seem like magic... but this..."
                    kthink "I notice the other plants in the vegetable garden, and they are all fully seasoned."
                    kthink "None of the plants are rotting or have a disease or pests."
                    kneutral "This is really strange.  I have not even watered them yet."
                    kthink "This is REAL magic."
                    kthink "I toss another seed into the soil and watch it grow right before my eyes."
                    kthink "I have so many questions regarding this strange phenomenon.  Is it the soil?  The seeds?"
                    kthink "Who made it this way?  The troll?  Alfrieda the witch?"
                    kthink "My wonder turns into amusement, and for the first time in a long while, I am able to smile again."
                    ksmile "With this kind of food, I shall never go hungry."
                    ksmile "Well, time for harvest!"
                    kthink "I pick %(yieldcabbage)d quantities of cabbage, %(yieldparsley)d quantities of parsley, %(yieldpotato)d quantities of potato, %(yieldonion)d quantities of onion and %(yieldasparagus)d quantities of asparagus."
                    ksmile "Not bad.  Next time maybe I can focus on a particular vegetable should I need more quantities of it."
                    ksmile "Now all I need to do is cook something up or make a salad."
                    $ first_meal = 1
                elif (first_meal == 1):
                    kneutral "I already have harvested some vegetables, but now I must cook them."
                elif (first_meal == 2):
                    kneutral "I have already eaten, I must find something else to do."
            if (locationscenario == 'errands'):
                kneutral "I inspect what I currently have."
                if (first_meal == 0):
                    menu:
                        "Harvest":
                            menu:
                                "Harvest All":
                                    $ yieldcabbage += renpy.random.randint(1, 5)
                                    $ yieldparsley += renpy.random.randint(1, 5)
                                    $ yieldpotato += renpy.random.randint(1, 5)
                                    $ yieldonion += renpy.random.randint(1, 5)
                                    $ yieldasparagus += renpy.random.randint(1, 5)
                                "Focus on Cabbage":
                                    $ yieldcabbage += renpy.random.randint(5, 10)
                                "Focus on Parsley":
                                    $ yieldparsley += renpy.random.randint(5, 10)
                                "Focus on Potato":
                                    $ yieldpotato += renpy.random.randint(5, 10)                        
                                "Focus on Onion":
                                    $ yieldonion += renpy.random.randint(5, 10)
                                "Focus on Asparagus":
                                    $ yieldasparagus += renpy.random.randint(5, 10)
                            kthink "I now have %(yieldcabbage)d quantities of cabbage, %(yieldparsley)d quantities of parsley, %(yieldpotato)d quantities of potato, %(yieldonion)d quantities of onion and %(yieldasparagus)d quantities of asparagus."
                            $ first_meal = 1
                        "Cancel":
                            kneutral "I can always return here anytime."
                elif (first_meal == 1):
                    kneutral "I already harvested enough vegetables, I must cook what I have first."                        
        if cottageresult == "well":
            kneutral "Time to grab a pail and fetch some water."
            scene cottagefrontS at LR with fade
            if (locationscenario == 'orientation'):
                if (well_visit == False):
                    kneutral "I feel so sticky down there."
                    kneutral "How am I supposed to take a bath?"
                    kthink "I look around me and realize that I am surrounded by forest."
                    kneutral "Well, there is no one around.  But what if the troll were watching me?"
                    kneutral "It does not matter anymore.  He has had me already."
                    kthink "I proceed to remove my clothes and start washing myself next to the well."
                    kthink "I spend a long time scrubbing myself clean."
                    scene cottageinside with fade
                    kthink "I rush back inside the cottage to get fresh replacements from the few items I was allowed to pack."
                    kthink "At length I finish dressing."
                    kneutral "At least now, I am physically clean."
                    kneutral "As for being spiritually clean, I suppose I cannot go to heaven anymore."
                    kthink "I will stay in hell with the troll."
                    kneutral "Although, if this is hell, it is not too bad."
                    scene cottagefrontS at LR with fade
                    kthink "I proceed to soak my old fluid-stained clothes."
                    $ well_visit = True
                    if (first_meal == 2):
                        jump afterorientation
                else:
                    kneutral "I have already washed myself, I must find something else to do."
            else:
                kneutral "I get myself a drink of water."
            if (haveflowers):
                kneutral "Hmmm... I have some wild flowers scattered around in my basket.  What could I do with them?"
                menu:
                    "Take the flowers out and decorate the cottage.":
                        scene cottageinside with fade
                        kthink "I fetch some vases from inside the cottage."
                        scene cottagefrontS at LR with fade
                        kthink "I place the flowers inside the vases, and fill them with water."
                        scene cottageinside with fade
                        kthink "I liven up my cottage with the vases full of yellow flowers."
                        $ haveflowers = False
                    "Keep the flowers in the basket.":
                        kthink "I think I can give these to some Alchemist who likes them."
        if cottageresult == "pathout":
            if (locationlock==False):
                ksmile "Going to the flower meadows!"
                $ location = 'meadows'
            else:
                kneutral "I cannot venture out, since Alfrieda and the troll forbid it!"
        elif cottageresult == "doorin":
            kneutral "I will go back inside the cottage."
            $ location = 'cottageinside'
    elif (location == 'meadows'):
        scene meadows with fade
        kneutral "Perhaps this place should be my garden instead."
        $ meadowsresult = renpy.imagemap(meadowsbase, meadowshover, [
            (480, 100, 800, 400, "flowers"),
            (0, 440, 280, 600, "town"), 
            (220, 100, 420, 240, "cottage"),
            (0, 160, 200, 280, "hut"),
            ], focus="imagemap")    
        play sound("click.ogg")
        if meadowsresult == "flowers":
            kneutral "The meadows sure are beautiful today."
            scene meadowsS at UR with fade
            if (haveflowers == False):
                ksmile "I can pick some flowers!"
                kthink "I indulge myself and take my time in picking the ones with the best petals."
                $ haveflowers = True
            else:
                kneutral "I still have flowers in my basket."
                kneutral "Come to think of it, my house could use some decoration as well."
                kneutral "I could use water from the well so they will not wilt."
        if meadowsresult == "town":
            $ renpy.music.stop(fadeout=1.0)
            ksmile "Proceeding to enter Nettestadt..."
            play music("nettestadtpre.ogg", "nettestadtpre.ogg", "nettestadtmain.ogg", "nettestadtmain.ogg", "nettestadtinter.ogg", "nettestadtinter.ogg", "nettestadtmain.ogg")
            $ location = 'milltavern'
        if meadowsresult == "hut":
            kneutral "Do I have business at Alfrieda's house?"
            scene meadowsS at UL with fade
            amad "What is it, Katja?  The troll has granted you more freedom, so you are now less reliant on me."
            kneutral "Nothing.  I am just dropping by to say hello."
            kthink "Alfrieda hesitates, then..."
            asmile "...thank, you, Katja.  That is sure appreciated."
        elif meadowsresult == "cottage":
            kneutral "I must venture deeper since my cottage is off the beaten path."
            $ location = 'cottagefront'
    elif (location == 'milltavern'):
        scene milltavern with fade
        if (locationscenario == 'errands'):
            kneutral "Here I am in the outskirts of town."
        if (locationscenario == 'troll'):
            kneutral "I must do this quickly.  So where should I look for the key?"
        $ milltavernresult = renpy.imagemap(milltavernbase, milltavernhover, [
            (20, 50, 340, 220, "tavern"),
            (540, 20, 800, 360, "mills"), 
            (0, 260, 200, 420, "downtown"),
            (600, 500, 800, 600, "exit"),
            ], focus="imagemap")    
        play sound("click.ogg")
        if milltavernresult == "tavern":
            if (locationscenario == 'troll'):
                kneutral "I will talk to the bartender.  Maybe he saw someone pick it up."
            if (locationscenario == 'errands'):
                kneutral "I might need to conduct some business with the bartender."
            scene milltavernS at UL with fade
            if (locationscenario == 'troll'):
                if (ts_visits < 4):
                    kscared "There is no one here!"
                    kneutral "Even though the gas lamps are all lighted.  Where could everyone be?"
                    $ ts_visits += 1
                    if (treasureone_location == 5) and (treasurefound == False):
                        call discovery1 from _call_discovery1_1
                else:
                    jump trollencounter
            if (locationscenario == 'errands'):  
                bartender "Oh Katja, welcome."                
                if (quest == "registrar book") and (registrar_stage == 2) and (writtennote == False):
                    kthink "I hand the bouquet of flowers to the bartender."
                    bartender "I will make sure it gets delivered."
                    kthink "This is strange.  Maybe there is some sort of coded message, and I am being used as an unwitting conspirator."
                    kthink "The bartender seems to have read my mind."
                    bartender "It is not really as bad as what you think, Katja."
                    bartender "Believe me, after the uprising, we do not really want to cause a revolution."
                    kneutral "What does the troll have to do with this?"
                    bartender "I see he has kept even you in the dark.  Well, even I do not know the full story."
                    kneutral "Who do you think the troll is?"
                    bartender "Are you asking my opinion?  I do not really have one.  Of course, I would rather that you tell me."
                    bartender "That is, if you already know him yourself."
                    bartender "But if it is just me, it is an equal chance it could be either Uwe or Jakob."
                    kthink "The bartender gives me a written note."
                    bartender "Give this to any Alchemist at the Hall, and you should be able to continue your errands."
                    $ writtennote = True
                else:
                    bartender "Care for a drink?  I was wondering what has happened to you."
                    kneutral "Thank you, but I am alright.  Just dropping by."
                kthink "I make some small talk with the bartender, until rough men enter and I feel I must get going."
        if milltavernresult == "mills":
            if (locationscenario == 'troll'):
                kneutral "I will talk to the miller again.  Perhaps he has a duplicate he can give me."
            if (locationscenario == 'errands'):
                kneutral "Perhaps I can trade with the miller."
            scene milltavernS at UR with fade
            if (locationscenario == 'troll'):
                if (ts_visits < 4):
                    kneutral "Well he left the gas lamps still on.  But the shop is closed now, and there is no one around."
                    $ ts_visits += 1
                    if (treasureone_location == 6) and (treasurefound == False):
                        call discovery1 from _call_discovery1_2
                else:
                    jump trollencounter
            if (locationscenario == 'errands'):
                if (nettestadter == nettestadtnight):
                    kneutral "That is strange, he used to keep the shop open late.  Maybe it is too late?"
                    kneutral "I should come back again in the morning."
                else:
                    if (notmillerpre):
                        miller "Oh, if it is not Katja!  I was worried that we would not see you anymore around here."
                        kneutral "Hello.  I am surprised, I thought everyone here hated me."
                        miller "On the contrary, you have quite a number of fans."
                        miller "So how is it, being the troll's wife?"
                        kneutral "You knew?"
                        miller "Well, a fanclub cannot exist without its rabid members."
                        miller "We also know that you were able to convince the troll to grant you freedom to move about."
                        miller "I like this new development.  It means we get to see you again."
                        miller "The problem is that, of course, we would rather that the troll had not taken you away from us."
                        miller "Even if that meant that the troll would be constantly in our midst.  At least my shops would be safe."
                        kneutral "What is the troll doing now?"
                        miller "Apart from a few notes here and there he drops certain people, no one has encountered him since."
                        kneutral "Who do you think is the troll?"
                        miller "What?  You do not know?  I thought that was what you were going to tell us, eventually!"
                        miller "Hmmm... he really must be under some witch's curse."
                        miller "It must be something that even the Alchemists are definitely not capable of."
                        miller "If I were to take a guess it would be Gerhard.  He knew you the best and for the longest time."
                        miller "Naturally he would not want to let you go.  He is the type to be brash enough to engage in this sort of selfishness."
                        kthink "The miller does seem to have a point."
                        miller "Well, I have rambled on enough."
                        $ notmillerpre = False
                    miller "Are you here for the diary, the meat shop, or the bakery?  They are all under one roof."
                    call purchasemiller from _call_purchasemiller_1
                    miller "You take care now, and do not mind the other people.  I still believe in you."
        if milltavernresult == "downtown":
            if (locationscenario == 'troll'):
                kneutral "I must retrace my steps downtown."
            else:
                kneutral "Venturing downtown..."
            $ location = 'downtown'
        elif milltavernresult == "exit":
            if (locationlock==False):
                $ renpy.music.stop(fadeout=1.0)
                kneutral "I must take my leave of Nettestadt."
                play music("blumenwaldmain.ogg", "blumenwaldpost.ogg", "blumenwaldpost.ogg", "blumenwaldmain.ogg", "blumenwaldpost.ogg") 
                $ location = 'meadows'
            else:
                kneutral "I cannot go out of town, it is too dangerous!"
    elif (location == 'downtown'):
        scene nettestadt with fade
        if (locationscenario == 'troll'):
            kneutral "I must do this quickly.  So where should I look for the key?"
        if (locationscenario == 'errands'):
            kneutral "All the major places are located downtown."
        $ downtownresult = renpy.imagemap(nettestadtbase, nettestadthover, [
            (0, 0, 350, 240, "castle"),
            (410, 110, 590, 260, "alchemy"), 
            (490, 400, 800, 600, "neighborhood"),
            (0, 350, 300, 560, "market"),
            (600, 245, 800, 310, "outskirts"),
            ], focus="imagemap")    
        play sound("click.ogg")
        if downtownresult == "castle":
            if (locationscenario == 'troll'):
                kneutral "I remember I did not venture this far."
            if (locationscenario == 'errands'):
                kneutral "I hope the guards are in a good mood today."
            scene nettestadtS at UL with fade
            if (locationscenario == 'troll'):
                if (ts_visits < 4):                
                    kneutral "Well, one can never be too sure."
                    kneutral "..."
                    kneutral "...nothing here."
                    $ ts_visits += 1
                    if (treasureone_location == 1) and (treasurefound == False):
                        call discovery1 from _call_discovery1_3
                else:
                    jump trollencounter
            if (locationscenario == 'errands'):
                if (quest == "statutes book"):
                    call guardsequence from _call_guardsequence_1
                else:
                    guard "Move along now, young lady, you have no business here... unless of course, you are the sort to consort with nobles."                                        
        if downtownresult == "alchemy":
            if (locationscenario == 'troll'):
                kneutral "I remember I did not venture this far."
            if (locationscenario == 'errands'):
                kneutral "This may be an interesting place."
            scene nettestadtS at UR with fade
            if (locationscenario == 'troll'):
                if (ts_visits < 4):                  
                    kneutral "Perhaps someone at the Hall of Alchemy can conjur up a replacement."
                    kthink "I knock at the door, hoping that someone is around, at the very least to answer it."
                    kneutral "...no one."
                    $ ts_visits += 1
                    if (treasureone_location == 2) and (treasurefound == False):
                        call discovery1 from _call_discovery1_4
                else:
                    jump trollencounter
            if (locationscenario == 'errands'):       
                if (quest == "registrar book"):
                    call alchemistsequence from _call_alchemistsequence_1
                else:
                    alchemist "You have to get going, Fraulein.  We are conducting many sensitive experiments."
                    kneutral "Oh, but..."
                    alchemist "Move along, Fraulein."
        if downtownresult == "market":
            if (locationscenario == 'errands'):
                if (notauntreunion):
                    kneutral "I will visit Aunt Heidi, to see how she is doing and tell her that I am well."
                else:
                    kneutral "I am thinking of trading my vegetables for gold."
            if (locationscenario == 'troll'):
                kneutral "Maybe I dropped it very close to home."
            scene nettestadtS at LL with fade
            if (locationscenario == 'troll'):
                if (ts_visits < 4):     
                    kneutral "..."
                    kneutral "...nothing."
                    $ ts_visits += 1
                    if (treasureone_location == 3) and (treasurefound == False):
                        call discovery1 from _call_discovery1_5
                else:
                    jump trollencounter
            if (locationscenario == 'errands'):
                if (nettestadter == nettestadtnight):
                    kneutral "But Aunt Heidi would never keep the shop open late.  I must come back again in the morning."
                else:
                    if (notauntreunion):
                        aunt "...Katja?"
                        ksmile "Yes, it is me."
                        villager "Get away from her!  She causes trouble."
                        aunt "But she is still my niece!"
                        villager "The troll's harlot!"
                        ovillager "She probably has some disease gotten from the troll by now."
                        kthink "I shrink away from the people who used to be my customers."
                        aunt "Is that a way to treat someone?  She is as much a victim of the troll as all of us."
                        aunt "Katja, do not mind these people.  To me, you are still like my own daughter."
                        kneutral "...I..."
                        kneutral "I am doing alright... I seem to be able to go to town now..."
                        aunt "We know, Katja.  Well, our stall is doing well, thankfully."
                        aunt "I am back to running it now, but you did a good job for the short time you manned it."
                        villager "So Katja, who is the troll?"
                        kneutral "I do not know."
                        villager "That is impossible!  He has taken your body, correct?"
                        kneutral "...yes."
                        villager "Then how can you not know him?  He would be practically naked!"
                        ovillager "Oh come on!  How can you be sure that the troll is human?"
                        villager "I am sure of it!"
                        ovillager "He is a real troll, I say!"
                        villager "Is not!"
                        ovillager "Is so!"
                        villager "I think the troll is Gerhard."
                        aunt "WHAT?"
                        villager "That playboy..."
                        villager "He knew he was the new stranger in town, but he wasted no time running around chasing the skirts of older women."
                        villager "So it is only natural that his soul will eternally harass old ladies the likes of us for ages to come!"
                        aunt "I do not want to hear about it!"
                        kneutral "I did not know Gerhard was... like that."
                        villager "Oh he is, my dear."
                        aunt "Let us stop this nonsense.  Katja, thank you for dropping by, but I sense you need something else."
                        kneutral "Aunt Heidi, I have a request... I have a garden where I can grow vegetables..."
                        kneutral "...but I have no money to buy other goods such as meat and milk.  Can I..."
                        aunt "Trade?  Surely.  Produce inspected and certified fresh by Heidi is fit for consumption..."
                        aunt "...is that not right, everyone?"
                        villager "...I...suppose so."
                        ovillager "Well, only because Heidi says so."
                        aunt "So, no problems Katja."
                        $ notauntreunion = False
                    aunt "So how may I help you?"
                    call selltoaunt from _call_selltoaunt_1
                    aunt "Have a nice day!"
        if downtownresult == "neighborhood":
            if (locationscenario == 'troll'):
                kneutral "This should be the place where I dropped it."
            if (locationscenario == 'errands'):
                kneutral "Perhaps I should take a quick stroll."
            scene nettestadtS at LR with fade
            if (locationscenario == 'troll'):
                if (ts_visits < 4):  
                    kneutral "Come on, where is it!"
                    kneutral "..."
                    kneutral "...not here."
                    $ ts_visits += 1
                    if (treasureone_location == 4) and (treasurefound == False):
                        call discovery1 from _call_discovery1_6
                else:
                    jump trollencounter
            if (locationscenario == 'errands'):
                if (oldwomannotencounteredyet) and (fertility_herbs == False):
                    kthink "I encounter an old woman selling herbs."
                    villager "I think I know you, but maybe I do not."
                    kneutral "Excuse me?"
                    villager "There was this woman who tried to sell me some golden flowers in exchange for some herbs to make her fertile..."
                    villager "But I do not know where she is now.  She looked just like you."
                    kneutral "Fertility Herbs?"
                    kthink "I wonder whether I will need such a thing."
                    kthink "Right now having a baby is furthest from my mind, especially with a troll for a husband."
                    kthink "But one can never predict what the future might bring."
                    kneutral "Do you use these golden flowers for the herbs?"
                    villager "Part of them.  You see, these plants are rare and therefore valuable."
                    villager "But they also have certain properties, even the Alchemists find some use for them."
                    villager "Me, I just use parts of them to make fertility herbs for sale.  The remaining parts I sell to the Alchemists."
                    if (treasures_found == 0):
                        kthink "I have not encountered any golden flowers."
                    if (treasures_found == 1):
                        kthink "I remember I picked up one of these things..."
                        kthink "It turns out I still have it in my pocket, and show it to the old woman."
                        kneutral "Is this the one?"
                        villager "Ah, do not go waving these things around, dear.  Be discreet.  Ah yes, that is the one."
                        villager "But for me to make fertility herbs in the right quantity, I need two of them."
                        villager "I would rather make concoctions in bulk, you see, not piecemeal."
                        kthink "Hmmm... I would probably want to find more of these things."
                    if (treasures_found < 2):
                        kneutral "Where can I find the golden flowers?  Blumenwald meadows?"
                        villager "Blumenwald is full of yellow flowers, but finding the rare golden variants is like finding a needle in a haystack."
                        villager "There are other places to find them, but most of the time it is just by accident."
                    if (treasures_found == 2):
                        kthink "I remember I encountered these things..."
                        kthink "It turns out I still have them in my pocket, and show them to the old woman."
                        kneutral "I have two of them."
                        villager "Ah, do not go waving these things around, dear.  Be discreet.  Ah yes, those are it."
                    $ oldwomannotencounteredyet = False
                else:
                    if (treasures_found < 2) or (fertility_herbs == True):
                        kthink "I wave at the old woman I encountered earlier and continue the enjoyable stroll."
                if (fertility_herbs == False) and (treasures_found == 2):
                    villager "So.  Would you you like to trade in your golden flowers in exchange for fertility herbs?"
                    menu:
                        "Yes":
                            $ fertility_herbs = True
                            kthink "I hand over the golden flowers to the old woman."
                            kthink "She tells me she can make the concoction in a few hours."
                            kthink "She goes to a small makeshift lab in one small corner of the neighborhood."
                            kthink "I spend my time idling about the neighborhood, then return to collect the herbs."
                            villager "Here you go dear.  Take these with water."
                            villager "Remember that these are not fully tested, even by the Alchemists, so some side effects are expected."
                            kscared "Side effects?  You should have told me that sooner!"
                            villager "Not to worry, nothing serious.  It is just that strange things may happen during intercourse..."
                            kthink "The old woman grins."
                            villager "But those who try them have a high success rate of getting pregnant."
                        "No":
                            kneutral "That is alright.  I might think about it next time."
                            villager "Such a shame.  I am sure such a buxom woman as yourself can produce and raise healthy children."
                            villager "Well, you know where to find me should you need them in the future."
                            kthink "I promptly take my leave."
        elif downtownresult == "outskirts":
            if (locationscenario == 'troll'):
                kneutral "I must retrace my steps on the outskirts of town."
            else:
                kneutral "Venturing towards the outskirts..."
            $ location = 'milltavern'
    jump locationcycler



    